Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 383915 - kde-base/kdelibs-4.7.1 fails to compile with libpng15
Summary: kde-base/kdelibs-4.7.1 fails to compile with libpng15
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Gentoo KDE team
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: libpng-1.5
  Show dependency tree
 
Reported: 2011-09-21 10:47 UTC by Francesco Riosa
Modified: 2011-09-24 15:37 UTC (History)
1 user (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
kdelibs-4.7.1:20110920-220338.log.gz (kdelibs-4.7.1:20110920-220338.log.gz,149.33 KB, application/octet-stream)
2011-09-21 10:47 UTC, Francesco Riosa
Details
kdelibs-4.7.1-libpng15.diff (kdelibs-4.7.1-libpng15.diff,498 bytes, patch)
2011-09-23 10:03 UTC, Lars Wendler (Polynomial-C)
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Francesco Riosa 2011-09-21 10:47:27 UTC
Created attachment 287255 [details]
kdelibs-4.7.1:20110920-220338.log.gz

see also bug #354479

I'm a bit in a hurry so please be easy on mistakes. I'll be more available in next days for more specific research if requested

revdep-rebuild -L /usr/lib64/libpng14.so.14 -- -pv

[ebuild   R    ] x11-libs/fltk-2.0_pre6970-r1  USE="cairo jpeg opengl png xft xinerama zlib -debug -doc" 0 kB
[ebuild   R    ] media-gfx/darktable-0.9.2-r2  USE="flickr gphoto2 kde nls openmp rawspeed slideshow -debug -gnome" 0 kB
[ebuild   R    ] kde-base/kdelibs-4.7.1  USE="3dnow acl alsa bzip2 debug handbook jpeg2k lzma mmx nls openexr opengl policykit semantic-desktop spell sse sse2 ssl udev udisks upower zeroconf (-altivec) (-aqua) -bindist -doc -fam (-kdeenablefinal) -kerberos -test -upnp" 0 kB                  
[ebuild   R    ] media-video/vlc-1.1.11  USE="X a52 aac alsa avahi bidi cdda cddb dbus dirac dts dvd ffmpeg flac gcrypt gnutls httpd jack kde live lua matroska mmx mp3 mpeg ncurses ogg opengl png pulseaudio qt4 rtsp samba schroedinger sdl sse stream svg taglib theora truetype udev v4l v4l2 vlm vorbis x264 xcb xml xv -aalib (-altivec) -atmo -dc1394 -debug -directfb -dvb -fbcon -fluidsynth -fontconfig -ggi -gme -gnome -id3tag -ieee1394 -kate -libass -libcaca -libnotify -libproxy -libtiger -libv4l -libv4l2 -lirc -modplug -mtp -musepack -nsplugin -optimisememory -oss -projectm -pvr -remoteosd -run-as-root -sdl-image -shine -shout -skins -speex -sqlite (-svga) -twolame -upnp -vaapi -vcdx (-win32codecs) -wma-fixed -xosd -zvbi" 0 kB
[ebuild     U  ] media-libs/opencv-2.3.0 [2.2.0-r10] USE="ffmpeg gstreamer jpeg jpeg2k openexr opengl png python qt4 sse sse2 sse3 ssse3 tiff v4l xine -cuda -doc -eigen -examples -gtk -ieee1394 (-ipp) -test" 0 kB                                                                                
[ebuild   R    ] media-gfx/imagemagick-6.7.2.6  USE="autotrace bzip2 corefonts cxx djvu fftw graphviz hdri jbig jpeg jpeg2k lcms lzma openexr openmp perl png raw static-libs svg tiff truetype webp xml zlib -X -fontconfig -fpx -gs -lqr -opencl -q32 -q64 -q8 -wmf" 0 kB                         
[ebuild   R    ] media-video/lives-1.4.2  USE="nls ogg theora -libvisual -matroska" 0 kB

Total: 7 packages (1 upgrade, 6 reinstalls), Size of downloads: 0 kB

all these packages fail to build

emerge --info

emerge --info
Portage 2.2.0_alpha59 (default/linux/amd64/10.0/no-multilib, gcc-4.6.0, glibc-2.13-r4, 3.0.3 x86_64)
=================================================================
System uname: Linux-3.0.3-x86_64-Intel-R-_Core-TM-2_Quad_CPU_Q8400_@_2.66GHz-with-gentoo-2.0.3
Timestamp of tree: Wed, 21 Sep 2011 10:00:01 +0000
ccache version 3.1.6 [disabled]
app-shells/bash:          4.2_p10
dev-java/java-config:     2.1.11-r3
dev-lang/python:          2.7.2-r3
dev-util/ccache:          3.1.6
dev-util/cmake:           2.8.5-r2
dev-util/pkgconfig:       0.26
sys-apps/baselayout:      2.0.3
sys-apps/openrc:          0.9.3-r1
sys-apps/sandbox:         2.5
sys-devel/autoconf:       2.13, 2.68
sys-devel/automake:       1.10.3, 1.11.1-r1
sys-devel/binutils:       2.21.1-r1
sys-devel/gcc:            4.5.3-r1, 4.6.0
sys-devel/gcc-config:     1.5-r1
sys-devel/libtool:        2.4-r1
sys-devel/make:           3.82-r3
sys-kernel/linux-headers: 2.6.39 (virtual/os-headers)
sys-libs/glibc:           2.13-r4
Repositories: gentoo vivovl x11
Installed sets: 
ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="*"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -march=core2 -pipe -msse4.1 --param=l1-cache-size=32 --param=l1-cache-line-size=64 --param=l2-cache-size=2048 -mtune=core2 -fgcse-after-reload -fpredictive-commoning -ftree-vectorize -funswitch-loops -fgraphite-identity -floop-block -floop-interchange -floop-strip-mine "
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/config /usr/share/gnupg/qualified.txt /usr/share/openvpn/easy-rsa /usr/share/themes/oxygen-gtk/gtk-2.0 /var/lib/hsqldb"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/env.d/java/ /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php5.3/ext-active/ /etc/php/cgi-php5.3/ext-active/ /etc/php/cli-php5.3/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-O2 -march=core2 -pipe -msse4.1 --param=l1-cache-size=32 --param=l1-cache-line-size=64 --param=l2-cache-size=2048 -mtune=core2 -fgcse-after-reload -fpredictive-commoning -ftree-vectorize -funswitch-loops -fgraphite-identity -floop-block -floop-interchange -floop-strip-mine  -fvisibility-inlines-hidden"
DISTDIR="/srv/distfiles"
EMERGE_DEFAULT_OPTS="--ask-enter-invalid"
FEATURES="assume-digests binpkg-logs buildpkg compress-build-logs distlocks ebuild-locks fixlafiles fixpackages metadata-transfer news noinfo parallel-fetch sandbox sfperms split-elog split-log strict test-fail-continue unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv"
FFLAGS=""
GENTOO_MIRRORS="http://mirror.netcologne.de/gentoo/ http://mirror.ovh.net/gentoo-distfiles/ http://mirror.switch.ch/ftp/mirror/gentoo/ http://gentoo.lagis.at/ http://mirror.qubenet.net/mirror/gentoo/"
LDFLAGS=""
LINGUAS="it"
MAKEOPTS="-j2"
PKGDIR="/g/packages"
PORTAGE_COMPRESS="lzma"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/srv/portage"
PORTDIR_OVERLAY="/g/ovl/tmp /g/ovl/x11"
SYNC="rsync://rsync.gentoo.org/gentoo-portage"
USE="3dnow X a52 aac acl akonadi alsa amd64 amr apache2 apm asf automount avahi avi bash-completion berkdb bitmap-fonts browserplugin bzip2 cairo caps captury cdda cddb chm cjk cli compositor consolekit cracklib crypt cups curl cxx dbus decibel declarative dedicated device-mapper djvu dri dvdread emboss encode engines erandom exif exiv2 extrafilters fam fame ffmpeg firefox flac foomaticdb fortran frei0r gallium gdbm geos gif glitz gpm gstreamer gtk2 hal hdf hdf5 hpijs hpn htmlhandbook iconv idn imagemagick imlib iproute2 ipv6 ithreads jack java jingle jpeg jpeg2k justify kde kdehiddenvisibility kdepim kontact latex libg++ libwww lua lzma lzo mad messenger mikmod mjpeg mmx mng modules motif mp3 mpeg mplayer mudflap mysql ncurses nepomuk new-hpcups newxkb nls nptl nptlonly odbc ogdi ogg openexr opengl openmp pam pam_chroot pcre perl plasma plugins png policykit pppd private-headers pulseaudio python qt qt3support qt4 quicktime rdesktop readline realtime reiserfs samba sasl scanner schroedinger screen sdl semantic-desktop server session skey slang smp social-desktop spell sqlite3 sse sse2 sse3 ssl ssse3 startup-notification static-libs svg sysfs system-sqlite taglib tcltk tcpd telepathy theora threads tiff tls truetype truetype-fonts ucs2 udev unicode urandom usb userlocales utempter utils v4l v4l2 vnc vorbis webkit x264 xcb xcomposite xine xinerama xml xorg xv xvid zeroconf zip zlib" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mmap_emul mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="actions alias auth_basic auth_digest authn_anon authn_dbd authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache dav dav_fs dav_lock dbd deflate dir disk_cache env expires ext_filter file_cache filter headers ident imagemap include info log_config logio mem_cache mime mime_magic negotiation proxy proxy_ajp proxy_balancer proxy_connect proxy_http rewrite setenvif so speling status unique_id userdir usertrack vhost_alias reqtimeout" APACHE2_MPMS="prefork" CALLIGRA_FEATURES="kexi words flow plan stage tables krita karbon braindump" CAMERAS="ptp2 directory canon" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" DRACUT_MODULES="bootchart btrfs crypt dmsquash-live mdraid syslog uswsusp" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ubx" INPUT_DEVICES="keyboard mouse evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LINGUAS="it" PHP_TARGETS="php5-3" QEMU_SOFTMMU_TARGETS="arm x86_64" QEMU_USER_TARGETS="arm x86_64" RUBY_TARGETS="ruby18" SANE_BACKENDS="hp4200 net ricoh" USERLAND="GNU" VIDEO_CARDS="nouveau" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CPPFLAGS, CTARGET, INSTALL_MASK, LANG, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS
Comment 1 Samuli Suominen gentoo-dev 2011-09-22 17:42:14 UTC
> kdelibs-4.7.1/khtml/imload/decoders/pngloader.cpp:201:13: error: invalid use of > incomplete type 'png_struct'
> /usr/include/png.h:827:16: error: forward declaration of 'png_struct'

from attached build.log
Comment 2 Francesco Riosa 2011-09-22 17:58:25 UTC
(In reply to comment #1)
> > kdelibs-4.7.1/khtml/imload/decoders/pngloader.cpp:201:13: error: invalid use of > incomplete type 'png_struct'
> > /usr/include/png.h:827:16: error: forward declaration of 'png_struct'
> 
> from attached build.log

Hi, I'm here now, 

/* The complete definition of png_struct has, as of libpng-1.5.0,
 * been moved into a separate header file that is not accessible to
 * applications.  Read libpng-manual.txt or libpng.3 for more info.
 */
typedef struct png_struct_def png_struct;
typedef PNG_CONST png_struct FAR * png_const_structp;
typedef png_struct FAR * png_structp;

...

/usr/share/doc/libpng-1.5.4/libpng-manual.txt.lzma or `man 3 libpng` in the section "II. Structures" explain what to do.

May/should I give some more information from my system?
Comment 3 Lars Wendler (Polynomial-C) gentoo-dev 2011-09-23 10:03:52 UTC
Created attachment 287481 [details, diff]
kdelibs-4.7.1-libpng15.diff

I'm writing this on behalf of ssuominen. 
Seems like the affected line can easily be commented out without problems. Mandriva is doing the same:

http://comments.gmane.org/gmane.linux.mandrake.cooker.commits/276759
Comment 4 Francesco Riosa 2011-09-23 11:47:47 UTC
(In reply to comment #3)
> Created attachment 287481 [details, diff]
> kdelibs-4.7.1-libpng15.diff
> 
> I'm writing this on behalf of ssuominen. 
> Seems like the affected line can easily be commented out without problems.
> Mandriva is doing the same:
> 
> http://comments.gmane.org/gmane.linux.mandrake.cooker.commits/276759

indeed it work, opening konqueror and looking at some png in the internet work too
Comment 5 Andreas K. Hüttel gentoo-dev 2011-09-24 15:37:01 UTC
Patch added in kdelibs-4.7.1-r1 and later.